# function for drawing the board in the terminal
def initialize_board():
	print(' ---' * 3)
	for i in range(3):
		print('|   ' * (3 + 1))
		print(' ---' * 3)

# function for drawing the board in the terminal to displaty steps
def draw_game_board(arr):
	p1 = 'o'
	p2 = 'x'
	emp= ' '
	print(' ---' * 3)
	for i in range(0, 3):
		for j in range(0, 3):
			if arr[i][j] == 1:
				print(f'| {p1} ', end = '')
			elif arr[i][j] == 2:
				print(f'| {p2} ', end = '')
			else:
				print(f'| {emp} ', end = '')
			if j == 2:
				print('|', end = '\n')
		print(' ---' * 3)

#function to determine who won the game
def win_lose(arr):
	# checking the horizontaly
	for x in range(0, 3):
		if arr[x][0] == arr[x][1] == arr[x][2]:
			if arr[x][0] == 1 and arr[x][1] == 1 and arr[x][2] == 1:
				return 1
			elif arr[x][0] == 2 and arr[x][1] == 2 and arr[x][2] == 2:
				return 2
	# checking the vertically
	for y in range(0, 3):
		if arr[0][y] == arr[1][y] == arr[2][y]:
			if arr[0][y] == 1 and arr[1][y] == 1 and arr[2][y] == 1:
				return 1
			elif arr[0][y] == 2 and arr[1][y] == 2 and arr[2][y] == 2:
				print(arr[y][0])
				return 2
	# checking the cross form left to right
	if arr[0][0] == arr[1][1] == arr[2][2]:
		if arr[0][0] == 1 and arr[1][1] == 1 and arr[2][2] == 1:
			return 1
		elif arr[0][0] == 2 and arr[1][1] == 2 and arr[2][2] == 2:
			return 2
	# checking the cross form right to left
	if arr[0][2] == arr[1][1] == arr[2][0]:
		if arr[0][2] == 1 and arr[1][1] == 1 and arr[2][0] == 1:
			return 1
		elif arr[0][2] == 2 and arr[1][1] == 2 and arr[2][0] == 2:
			return 2
	elif 0 not in internal_board[0] and 0 not in internal_board[1] and 0 not in internal_board[2]:
		return 0

# 3X array as an internal board
internal_board = [[0, 0, 0],
                  [0, 0, 0],
                  [0, 0, 0]]
# drawing the board
initialize_board()

while True:
	#if there is still space on the board for Player 1
	if win_lose(internal_board) != 0 and win_lose(internal_board) != 1 and win_lose(internal_board) != 2:
		# asking Player 1 (o) for coordinates
		while True:
			p1_step = list(input('\nPlayer 1, row&column for o: '))
			# if the input coordinates are out of the board
			if int(p1_step[0]) > 2  or int(p1_step[1]) > 2:
				print('One of specified coordinates is larger than the board!!')
				continue
			else:
		# if the current coordinate was already taken (not 0)
				if internal_board[int(p1_step[0])][int(p1_step[1])] != 0:
					print('This coordinate is already taken!!!')
					continue
		# entering 1 (o) witin the internal array for Player 1
				else:
					internal_board[int(p1_step[0])][int(p1_step[1])] = 1
					# printing out the boars to see the game
					draw_game_board(internal_board)
					break
		else:
			if win_lose(internal_board) == 1:
				print('\nPlayer 1 wins!!!')
			elif win_lose(internal_board) == 2:
				print('\nPlayer 2 wins!!!')
			elif win_lose(internal_board) == 0:
				print('\nIts a tie')
			break

	#if there is still space on the board for Player 1
	if win_lose(internal_board) != 0 and win_lose(internal_board) != 1 and win_lose(internal_board) != 2:
		# asking Player 2 (o) for coordinates
		while True:
			p2_step = list(input('\nPlayer 2, row&column for x: '))
			# if the input coordinates are out of the board
			if int(p2_step[0]) > 2  or int(p2_step[1]) > 2:
				print('One of specified coordinates is larger than the board!!')
				continue
			else:
				# if the current coordinate was already taken (not 0)
				if internal_board[int(p2_step[0])][int(p2_step[1])] != 0:
					print('This coordinate is already taken!!!')
					continue
				# entering 1 (o) witin the internal array for Player 1
				else:
					internal_board[int(p2_step[0])][int(p2_step[1])] = 2
					# printing out the boars to see the game
					draw_game_board(internal_board)
					break
	else:
		if win_lose(internal_board) == 1:
			print('\nPlayer 1 wins!!!')
		elif win_lose(internal_board) == 2:
			print('\nPlayer 2 wins!!!')
		elif win_lose(internal_board) == 0:
			print('\nIts a tie')
		break
